/////////////////////////////////////////////////////////////////////////////
//
// Undelete
//
// Copyright (C) 1998 Mark Russinovich and Bryce Cogswell
// Systems Internals - http://www.sysinternals.com
//
// See readme.txt for terms of use.
//
/////////////////////////////////////////////////////////////////////////////

//
// Extension length (3 characters + '.' + terminating null)
//
#define EXT_LEN		10

//
// ShellState flag for explorer
//
#define SHELLPROMPTFLAG 0x4

//
// This is an entry in the filter array for the registry
//
typedef struct {
  char       filter[EXT_LEN];
} FILTERENTRY, *PFILTERENTRY;


#define GLOBAL_SETTING 27
typedef struct {
    // actual information  
	ULONG	    SizeOfInformation;
	ULONG	    EnforceGlobalSetting;

	// Space for each recycle bin if settings are per-drive
	USHORT	    ReservedForRecycle[28];

	// If settings are not global, mask determines which volumes have
	// recycling disabled
	ULONG	    RecycleDisableMask;
	ULONG	    Unknown;
} PURGE_INFORMATION, *PPURGE_INFORMATION;


//
// Have to pack these
//
#pragma pack(1)

//
// Type of recycle bin
//
#define ANSI_RECYCLE_TYPE    0x0
#define UNICODE_RECYCLE_TYPE 0x2


#define UNICODE_VERSION_SIG  0x320
#define ANSI_VERSION_SIG     0x118

//
// This is the header on the front of the INFO file
//
typedef struct {
    ULONG       Version;   // must be 2
	ULONG       Entries; 
    ULONG       NextID; 
	ULONG       VersionSignature; 
    ULONG       Reserved2;
} INFO_HEADER, *PINFO_HEADER;

//
// NOTE: the undelete code relies on the fact that the
// ANSI info entry structure is an exact subset of the 
// UNICODE info entry structure
//

//
// This is an entry in the unicode INFO file
//
typedef struct {
        UCHAR       AsciiName[0x104];   
        ULONG       FileID; 
        ULONG       Drive;       // 0-based
        LARGE_INTEGER TimeDeleted;
        ULONG       Reserved1;   // don't care
        WCHAR       UnicodeName[0x104];
} UNIINFO_ENTRY, *PUNIINFO_ENTRY;

//
// This is an entry in the ansi INFO file
//
typedef struct {
        UCHAR       AsciiName[0x104];   
        ULONG       FileID; 
        ULONG       Drive;       // 0-based
        LARGE_INTEGER TimeDeleted;
        ULONG       Reserved1;   // don't care
} ANSIINFO_ENTRY, *PANSIINFO_ENTRY;

#pragma pack()

